tweak some of the log output inconsequentially
[monkeysphere.git] / tests / basic
index 5e233aa0014ec9d9b801daa6c0beb837f27f500f..9844454543b53d42f525e150ec5587b123c421af 100755 (executable)
@@ -17,6 +17,11 @@ set -e
 # piped commands should return the code of the first non-zero return
 set -o pipefail
 
+# make sure the TESTDIR is an absolute path, not a relative one.
+export TESTDIR=$(cd $(dirname "$0") && pwd)
+
+source "$TESTDIR"/common
+
 ## make sure that the right tools are installed to run the test.  the
 ## test has *more* requirements than plain ol' monkeysphere:
 which socat >/dev/null || { echo "You must have socat installed to run this test." ; exit 1; }
@@ -28,6 +33,7 @@ which socat >/dev/null || { echo "You must have socat installed to run this test
 
 # gpg command for test admin user
 gpgadmin() {
+    chmod 0700 "$TEMPDIR"/admin
     GNUPGHOME="$TEMPDIR"/admin/.gnupg gpg "$@"
 }
 
@@ -72,34 +78,6 @@ ssh_test() {
     fi
 }
 
-failed_cleanup() {
-    # FIXME: can we be more verbose here?
-    echo 'FAILED!'
-    read -p "press enter to cleanup and remove tmp:"
-
-    cleanup
-}
-
-get_gpg_prng_arg() {
-    if (gpg --quick-random --version >/dev/null 2>&1) ; then
-       echo quick-random
-    elif (gpg --debug-quick-random --version >/dev/null 2>&1) ; then
-       echo debug-quick-random
-    fi
-}
-
-cleanup() {
-    echo "### removing temp dir..."
-    rm -rf "$TEMPDIR"
-
-    if [ "$SSHD_PID" ] ; then
-       echo "### killing off lingering sshd..."
-       kill "$SSHD_PID"
-    fi
-
-    wait
-}
-
 SSHD_PID=
 
 ## setup trap
@@ -112,15 +90,16 @@ trap failed_cleanup EXIT
 ## set up some variables to ensure that we're operating strictly in
 ## the tests, not system-wide:
 
-export TESTDIR=$(dirname "$0")
+# set up temp dir
+
+# NOTE: /tmp can not be used as the temp dir here, since the
+# permissions on /tmp are usually such that they will not pass the
+# monkeysphere/ssh path permission checking.  If you need to use a
+# different location than the current source, please set $TMPDIR
+# somewhere with tighter permissions.
 
-# make temp dir
-TEMPDIR="$TESTDIR"/tmp
-if [ -e "$TEMPDIR" ] ; then
-    echo "tempdir '$TEMPDIR' already exists."
-    exit 1
-fi
-mkdir "$TEMPDIR"
+mkdir -p "$TESTDIR"/tmp
+TEMPDIR=$(mktemp -d "${TMPDIR:-$TESTDIR/tmp}/monkeyspheretest.XXXXXXX")
 
 # Use the local copy of executables first, instead of system ones.
 # This should help us test without installing.
@@ -149,13 +128,12 @@ export DISPLAY=monkeys
 
 # copy in admin and testuser home to tmp
 echo "##################################################"
-echo "### copying admin and testuser homes..."
-cp -a "$TESTDIR"/home/admin "$TEMPDIR"/
+echo "### configuring testuser home..."
 cp -a "$TESTDIR"/home/testuser "$TEMPDIR"/
-
 # set up environment for testuser
-TESTHOME="$TEMPDIR"/testuser
+export TESTHOME="$TEMPDIR"/testuser
 export GNUPGHOME="$TESTHOME"/.gnupg
+chmod 0700 "$GNUPGHOME"
 export SSH_ASKPASS="$TESTHOME"/.ssh/askpass
 export MONKEYSPHERE_HOME="$TESTHOME"/.monkeysphere
 cat <<EOF >> "$TESTHOME"/.ssh/config
@@ -168,6 +146,10 @@ KNOWN_HOSTS=$TESTHOME/.ssh/known_hosts
 EOF
 get_gpg_prng_arg >> "$GNUPGHOME"/gpg.conf
 
+echo "##################################################"
+echo "### configuring admin home..."
+cp -a "$TESTDIR"/home/admin "$TEMPDIR"/
+
 # set up sshd
 echo "##################################################"
 echo "### configuring sshd..."
@@ -182,25 +164,24 @@ EOF
 ######################################################################
 ### SERVER HOST SETUP
 
-# set up monkeysphere host
+# import host key
 echo "##################################################"
-echo "### configuring monkeysphere host..."
-mkdir -p -m 750 "$MONKEYSPHERE_SYSDATADIR"/host
+echo "### testing host key importing..."
+ssh-keygen -b 1024 -t rsa -N '' -f "$TEMPDIR"/ssh_host_rsa_key
+monkeysphere-host expert import-key testhost < "$TEMPDIR"/ssh_host_rsa_key
 
-# create a new host key
+# change host key expiration
 echo "##################################################"
-echo "### generating server host key..."
-# add gpg.conf with quick-random
-get_gpg_prng_arg >> "$MONKEYSPHERE_SYSCONFIGDIR"/host/gpg.conf
-echo | monkeysphere-host expert gen-key --length 1024 --expire 0 testhost
-# remove the gpg.conf
-rm "$MONKEYSPHERE_SYSCONFIGDIR"/host/gpg.conf
-
-# FIXME: need to test import-key as well
+echo "### setting host key expiration..."
+monkeysphere-host set-expire 1
+# FIXME: how do we check that the expiration has really been set?
 
+echo "##################################################"
+echo "### getting host key fingerprint..."
 HOSTKEYID=$( monkeysphere-host show-key | grep '^OpenPGP fingerprint: ' | cut -f3 -d\  )
+echo "$HOSTKEYID"
 
-# certify it with the "Admin's Key".
+# certify host key with the "Admin's Key".
 # (this would normally be done via keyservers)
 echo "##################################################"
 echo "### certifying server host key..."
@@ -223,7 +204,7 @@ echo "##################################################"
 echo "### setup monkeysphere authentication..."
 cp "$TESTDIR"/etc/monkeysphere/monkeysphere-authentication.conf "$TEMPDIR"/
 cat <<EOF >> "$TEMPDIR"/monkeysphere-authentication.conf
-AUTHORIZED_USER_IDS="$MONKEYSPHERE_HOME/authentication/authorized_user_ids"
+AUTHORIZED_USER_IDS="$MONKEYSPHERE_HOME/authorized_user_ids"
 EOF
 monkeysphere-authentication setup
 get_gpg_prng_arg >> "$MONKEYSPHERE_SYSDATADIR"/authentication/sphere/gpg.conf
@@ -231,10 +212,13 @@ get_gpg_prng_arg >> "$MONKEYSPHERE_SYSDATADIR"/authentication/sphere/gpg.conf
 # add admin as identity certifier for testhost
 echo "##################################################"
 echo "### adding admin as certifier..."
-echo y | monkeysphere-authentication add-id-certifier "$TEMPDIR"/admin/.gnupg/pubkey.gpg
+monkeysphere-authentication add-id-certifier -y "$TEMPDIR"/admin/.gnupg/pubkey.gpg
 
-# FIXME: should we run "diagnostics" here to test setup?
+echo "##################################################"
+echo "### list certifiers..."
+monkeysphere-authentication list-certifiers
 
+# FIXME: should we run "diagnostics" here to test setup?
 
 ######################################################################
 ### TESTUSER SETUP
@@ -252,18 +236,20 @@ gpgadmin --armor --export "$HOSTKEYID" | gpg --import
 # teach the "server" about the testuser's key
 echo "##################################################"
 echo "### export testuser key to server..."
-gpg --export testuser | monkeysphere-authentication gpg-cmd --import
+gpg --export testuser | monkeysphere-authentication expert gpg-cmd --import
 
 # update authorized_keys for user
 echo "##################################################"
 echo "### update server authorized_keys file for this testuser..."
 monkeysphere-authentication update-users $(whoami)
+# FIXME: NOT FAILING PROPERLY FOR:
+# ms: improper group or other writability on path '/tmp'.
 
 
 ######################################################################
 ### TESTS
 
-# connect to test sshd, using monkeysphere-ssh-proxycommand to verify
+# connect to test sshd, using monkeysphere ssh-proxycommand to verify
 # the identity before connection.  This should work in both directions!
 echo "##################################################"
 echo "### ssh connection test for success..."
@@ -301,6 +287,7 @@ chmod o-w "$TESTHOME"/.monkeysphere/authorized_user_ids
 
 # FIXME: addtest: remove admin as id-certifier and check ssh failure
 
+# FIXME: addtest: add hostname on host key
 # FIXME: addtest: revoke hostname on host key and check ssh failure
 
 # FIXME: addtest: revoke the host key and check ssh failure